/**Dieses Ampelprojekt ist eine umfangreiche und kommentierte Lösung zu Arbeitsblatt 3.*/
public class Ampel
{
    //Anlegen und Initialisieren der Attribute
    Rechteck hintergrund = new Rechteck();
    Rechteck r           = new Rechteck();
    Kreis    krOben      = new Kreis();
    Kreis    krMitte     = new Kreis();
    Kreis    krUnten     = new Kreis();
     
    /**Der Konstruktor "baut" die Ampel in ihrer Grundform und Farbe zu Beginn zusammen.*/
    public Ampel()
    {
        /*Jede Komponente bekommt Größe, Position und Farbe zugewiesen.
        Die Position wird als x- und y-Koordinate angegeben, wobei der 
        Ursprung in der oberen linken Ecke liegt.*/
        hintergrund.setzeGroesse(900,700);
        hintergrund.setzeMittelpunkt(450,350);
        hintergrund.setzeFarbe("Weiß");
        
        r.setzeGroesse(120, 370);
        r.setzeMittelpunkt(450,300);
        r.setzeFarbe("Schwarz");
        
        /*Achtung: die Methode "setzeGroesse(int breite, int hoehe)" 
        heißt hier setzeRadius(int radius)!*/
        krOben.setzeRadius(50); 
        krOben.setzeMittelpunkt(450,180);
        krOben.setzeFarbe("Rot");
        
        krMitte.setzeRadius(50);
        krMitte.setzeMittelpunkt(450,300);
        krMitte.setzeFarbe("Gelb");
        
        krUnten.setzeRadius(50);
        krUnten.setzeMittelpunkt(450,420);
        krUnten.setzeFarbe("Grün");
    }
    
    public void schalteRot()
    {
        //Farben setzen
        krOben.setzeFarbe("Rot");
        krMitte.setzeFarbe("Schwarz");
        krUnten.setzeFarbe("Schwarz");
        
        //Zustandsausgaben zur eigenen Kontrolle auf der Konsole
        System.out.println("-> Methodenaufruf schalteRot()\n");
        druckeStatus();
    }
    
    public void schalteGelbRot()
    {
        //Farben setzen
        krOben.setzeFarbe("Rot");
        krMitte.setzeFarbe("Gelb");
        krUnten.setzeFarbe("Schwarz");
        
        //Zustandsausgaben zur eigenen Kontrolle auf der Konsole
        System.out.println("-> Methodenaufruf schalteGelbRot()\n");
        druckeStatus();
    }
    
    public void schalteGelb()
    {
        //Farben setzen
        krOben.setzeFarbe("Schwarz");
        krMitte.setzeFarbe("Gelb");
        krUnten.setzeFarbe("Schwarz");
        
        //Zustandsausgaben zur eigenen Kontrolle auf der Konsole
        System.out.println("-> Methodenaufruf schalteGelb()\n");
        druckeStatus();
    }
    
    public void schalteGruen()
    {
        //Farben setzen
        krOben.setzeFarbe("Schwarz");
        krMitte.setzeFarbe("Schwarz");
        krUnten.setzeFarbe("Grün");
        
        //Zustandsausgaben zur eigenen Kontrolle auf der Konsole
        System.out.println("-> Methodenaufruf schalteGruen()\n");
        druckeStatus();
    }
    
    /**Diese Methode schaltet einmal durch drei Phasen durch.
       Zum Zeitpunkt der Programmierung war die Methode schalteGelbRot()
       noch nicht vorhanden.
       
       Die Wartedauer wird bei Methodenaufruf abgefragt und übergeben.*/
    public void schalteAllePhasen(int dauer)
    {
        schalteGruen();
        warten(dauer);
        schalteGelb();
        warten(dauer);
        schalteRot();
    }
    
    /** Startet die Ampel in einer Endlosschleife, die Wartedauer ist festgelegt.*/
    public void start(){
        int dauer = 500;
        while(true){ //Diese Bedingung ist immer wahr, da wahr wahr ist. :)
            schalteGruen();
            warten(dauer);
            
            schalteGelb();
            warten(dauer);
            
            schalteRot();
            warten(dauer);
            
            schalteGelbRot();
            warten(dauer);
        }
    }
    
    
    /** Startet die Ampel mit variabler 
     * Anzahl der Durchläufe,
     * Grünphase in ms
     * und Rotphase in ms.
       
       Die Gelb, bzw. Gelb-Rot-Phase dauern immer 500 ms.
       
       In dieser Methode wird eine alternative Methode verwendet, die Durchläufe
       zu zählen. Hier wird nicht bis 0 heruntergezählt, sondern eine eigene Variable
       hochgezählt.*/
    public void start(int durchlaeufe, int dauerGruenPhase, int dauerRotPhase){
        int dauer = 500; //Wartedauer Gelb-Phase, Gelb-Rot-Phase
        int durchlaeufeBisher = 0; //Anzahl der bisherigen Durchläufe
        
        //Solange insgesamt mehr Durchläufe gemacht werden sollen, als bisher absolviert, ...
        while(durchlaeufe > durchlaeufeBisher){
            schalteGruen();
            warten(dauerGruenPhase);
            
            schalteGelb();
            warten(dauer);
            
            schalteRot();
            warten(dauerRotPhase);
            
            schalteGelbRot();
            warten(dauer);
            
            durchlaeufeBisher++; //Zähle die anzahl der Durchläufe eins nach oben.
        }
    }
    
    /**Die toString()-Methode erstellt einen String, in dem der Zustand des Ampelobjekts
    beschrieben wird und gibt diesen zurück*/
    public String toString()
    {
        String ausgabe = "** Ampelstatus **";
        /* Um an die gewünschten Informationen zu gelangen, verwenden wir die "Getter-Methode" der
           Kreise. Diese heißt hier "nenneFarbe()". */
        ausgabe += "\n --> oberes Licht   : "+krOben.nenneFarbe();  //mit += werden weitere Strings
        ausgabe += "\n --> mittleres Licht: "+krMitte.nenneFarbe(); //an den schon vorhanden String
        ausgabe += "\n --> unteres Licht  : "+krUnten.nenneFarbe(); //gehängt. 
        ausgabe += "\n";
        
        return ausgabe; //Ist der Ausgabe-String fertig gebaut, wird dieser zurück gegeben.
    }
    
    /**Diese Methode gibt den Status-String aus der toString()-Methode auf der Konsole aus.*/
    public void druckeStatus()
    {
        System.out.println(toString());
    }
    
    /**Die warten(int ms)-Methode versetzt das Programm für die übergebene Anzahl von Millisekunden in 
     * einen Schlafzustand. Wie das genau funktioniert ist erstmal weiter nicht wichtig.*/
    public void warten(int ms)
    {
        try{
            Thread.sleep(ms);
        }catch(InterruptedException e){}
    }
}
